/*
** File: dpc.c  
** Project: VxWorks Driver Framework
** Purpose: Deferred procedure call stub (using isrDeferLib)
**
** (C) Copyright Alpha Data 2010
*/

#include "df.h"
#include "dfvxworks.h"

void
_dfVxwIsrDeferStub(
  void* pContext)
{
  DfDpc* pDpc = (DfDpc*)pContext;

  pDpc->system.pFunction(pDpc, pDpc->system.pContext, pDpc->system.pArg);
  if (dfAtomicDec(&pDpc->system.refCount) == 0) {
    dfEventSignal(pDpc->system.pEvent);
  }
}

void
_dfVxwExcJobStub(
#if DFVXW_HAS_VX_USR_ARG_T
  _Vx_usr_arg_t arg1, /* pDpc */
  _Vx_usr_arg_t arg2, /* pArg passed to dfDpcSchedule */
  _Vx_usr_arg_t arg3,
  _Vx_usr_arg_t arg4,
  _Vx_usr_arg_t arg5,
  _Vx_usr_arg_t arg6)
#else
  int arg1, /* pDpc */
  int arg2, /* pArg passed to dfDpcSchedule */
  int arg3,
  int arg4,
  int arg5,
  int arg6)
#endif
{
  DfDpc* pDpc = (DfDpc*)arg1;

  pDpc->system.pFunction(pDpc, pDpc->system.pContext, (void*)(uintptr_t)arg2);
  if (dfAtomicDec(&pDpc->system.refCount) == 0) {
    dfEventSignal(pDpc->system.pEvent);
  }
}
